package com.three_petals;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;

import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;
import com.facebook.SessionState;
import com.facebook.UiLifecycleHelper;
import com.facebook.model.GraphUser;
import com.three_petals.activity.LoginMenu;
import com.three_petals.activity.MainMenu;
import com.three_petals.info.User;
import com.three_petals.utils.MakeLog;

public class MainActivity extends Activity
{
    public static MainActivity instance = null;
    private UiLifecycleHelper uiHelper;

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        instance = this;
        uiHelper = new UiLifecycleHelper(this, callback);
        uiHelper.onCreate(savedInstanceState);
    }

    @Override
    protected void onResume()
    {
        super.onResume();
        uiHelper.onResume();
        affGoodView();
    }

    private static void affGoodView()
    {
        Session session = Session.getActiveSession();

        if (session != null)
        {
            if (session.isOpened())
            {
                Request.newMeRequest(session, new Request.GraphUserCallback()
                {
                    @Override
                    public void onCompleted(GraphUser user, Response response)
                    {
                        if (user != null)
                        {
                            MakeLog.log("user != NULL (MainActivity");
                            User.initInstance(user);
                            MainMenu.AffMainMenu(instance);
                        }
                        else
                        {
                            MakeLog.log("user = NULL (MainActivity");
                            LoginMenu.affLoginMenu();
                        }
                    }

                }).executeAsync();
            }
            else
            {
                LoginMenu.affLoginMenu();
            }
        }
        else
        {
            LoginMenu.affLoginMenu();
        }
    }

    private Session.StatusCallback callback = new Session.StatusCallback()
    {
        @Override
        public void call(Session session, SessionState state, Exception exception)
        {
            onSessionStateChange(session, state, exception);
        }
    };

    @Override
    protected void onPause()
    {
        super.onPause();
        uiHelper.onPause();
    }

    @Override
    protected void onDestroy()
    {
        super.onDestroy();
        uiHelper.onDestroy();
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        super.onActivityResult(requestCode, resultCode, data);
        Session.getActiveSession().onActivityResult(this, requestCode, resultCode, data);
        uiHelper.onActivityResult(requestCode, resultCode, data);
    }

    @Override
    protected void onSaveInstanceState(Bundle outState)
    {
        super.onSaveInstanceState(outState);
        uiHelper.onSaveInstanceState(outState);
    }

    private void onSessionStateChange(Session session, SessionState state, Exception exception)
    {
        if (state.equals(SessionState.OPENED))
        {
        } else if (state.isClosed())
        {
        }
    }
}
