package com.three_petals.activity;

import android.app.Activity;
import android.content.ClipData;
import android.content.ClipDescription;
import android.content.Context;
import android.content.Intent;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.view.DragEvent;
import android.view.View;
import android.view.View.DragShadowBuilder;
import android.view.View.OnDragListener;
import android.view.View.OnLongClickListener;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.Toast;

import com.example.three_petals.R;

public class Custom_picture extends Activity
{
    private static BitmapDrawable _ob;
    private ImageView myImage;
    public static void affCustomPicture(Context context, BitmapDrawable ob)
    {
        _ob = ob;
        Intent intent = new Intent(context, Custom_picture.class);
        context.startActivity(intent);
        ((Activity) context).finish();
    }
    
    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.menu_custom_picture);
        RelativeLayout img = (RelativeLayout) findViewById(R.id.bottomlinear);
        img.setBackground(_ob);
        myImage = (ImageView) findViewById(R.id.image);
        myImage.setOnLongClickListener(new MyClickListener());
        findViewById(R.id.toplinear).setOnDragListener(new MyDragListener());
        findViewById(R.id.bottomlinear).setOnDragListener(new MyDragListener());
    }

    private final class MyClickListener implements OnLongClickListener
    {
        @Override
        public boolean onLongClick(View view)
        {
            ClipData.Item item = new ClipData.Item((CharSequence) view.getTag());
            String[] mimeTypes = { ClipDescription.MIMETYPE_TEXT_PLAIN };
            ClipData data = new ClipData("", mimeTypes, item);
            DragShadowBuilder shadowBuilder = new View.DragShadowBuilder(view);
            view.startDrag(data,shadowBuilder, view, 0);
            return true;
        }
    }

    class MyDragListener implements OnDragListener
    {
        @Override
        public boolean onDrag(View v, DragEvent event)
        {
            switch (event.getAction())
            {
            case DragEvent.ACTION_DRAG_STARTED:
                break;

            case DragEvent.ACTION_DRAG_ENTERED:
                break;

            case DragEvent.ACTION_DRAG_EXITED:
                break;

            case DragEvent.ACTION_DROP:
                if (v == findViewById(R.id.bottomlinear))
                {
                    View view = (View) event.getLocalState();
                    ViewGroup viewgroup = (ViewGroup) view.getParent();
                    viewgroup.removeView(view);

                    view.setX(event.getX());
                    view.setY(event.getY());
                    RelativeLayout containView = (RelativeLayout) v;
                    containView.addView(view);
                }
                else
                {
                    Context context = getApplicationContext();
                    Toast.makeText(context, "You can't drop the image here", Toast.LENGTH_LONG).show();
                    break;
                }
                break;
            case DragEvent.ACTION_DRAG_ENDED:
                break;
            default:
                break;
            }
            return true;
        }
    }
}