package com.three_petals.activity;

import java.io.IOException;
import java.util.List;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.PixelFormat;
import android.graphics.drawable.BitmapDrawable;
import android.hardware.Camera;
import android.hardware.Camera.PictureCallback;
import android.os.Bundle;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.ImageView;

import com.example.three_petals.R;

public class TakePhotoActivity extends Activity implements SurfaceHolder.Callback
{
    private Camera camera;
    private SurfaceView surfaceCamera;
    private Boolean isPreview;
    private TakePhotoActivity intent = null;
    
    public static void affTakePhoto(Context context)
    {
        Intent intent = new Intent(context, TakePhotoActivity.class);
        context.startActivity(intent);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

        getWindow().setFormat(PixelFormat.TRANSLUCENT);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);

        isPreview = false;
        camera = null;
        surfaceCamera = null;
        intent = this;

        setContentView(R.layout.menu_take_photo);

        Button takePicture = (Button) findViewById(R.id.btn_take_picture);
        surfaceCamera = (SurfaceView) findViewById(R.id.surfaceViewCamera);

        takePicture.setOnClickListener(new OnClickListener()
        {
            @Override
            public void onClick(View v)
            {
                if (camera != null)
                {
                    camera.takePicture(null, rawCallback, jpegCallback);
                }
            }
        });

        InitializeCamera();
    }

    @Override
    public void onResume()
    {
        super.onResume();
        camera = Camera.open();
        camera.setDisplayOrientation(90);
    }

    @Override
    public void onPause()
    {
        super.onPause();

        if (camera != null)
        {
            camera.release();
            camera = null;
        }
    }

    PictureCallback rawCallback = new PictureCallback() {
        public void onPictureTaken(byte[] data, Camera camera)
        {

        }
    };

    PictureCallback jpegCallback = new PictureCallback() {
        public void onPictureTaken(byte[] data, Camera camera)
        {
            Log.e("JpegCallBack", new String(data));
            Bitmap pictureTaken = BitmapFactory.decodeByteArray(data, 0, data.length);
            BitmapDrawable ob = new BitmapDrawable(pictureTaken);
            Custom_picture.affCustomPicture(intent, ob);
        }
    };

    private void InitializeCamera()
    {
        surfaceCamera.getHolder().addCallback(this);
        surfaceCamera.getHolder().setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }

    @Override
    public void surfaceChanged(SurfaceHolder holder, int format, int width, int height)
    {
        if (isPreview)
        {
            camera.stopPreview();
        }

        Camera.Parameters parameters = camera.getParameters();
        List<Camera.Size> sizes = parameters.getSupportedPreviewSizes();
        Camera.Size cs = sizes.get(0);
        parameters.setPreviewSize(cs.width, cs.height);
        camera.setParameters(parameters);

        try
        {
            camera.setPreviewDisplay(surfaceCamera.getHolder());
        }
        catch (IOException e)
        {
        }
        camera.startPreview();
        isPreview = true;
    }

    @Override
    public void surfaceCreated(SurfaceHolder holder)
    {
        if (camera == null)
        {
            camera = Camera.open();
            camera.setDisplayOrientation(90);
        }
    }

    @Override
    public void surfaceDestroyed(SurfaceHolder holder)
    {
        if (camera != null)
        {
            camera.stopPreview();
            isPreview = false;
            camera.release();
        }
    }
}
