package com.three_petals.activity.content;

import com.example.three_petals.R;
import com.three_petals.fragments.MainTabFragment;

import android.app.ActionBar;
import android.app.FragmentTransaction;
import android.app.ActionBar.Tab;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;
import android.support.v4.view.ViewPager;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

public class NewsFragment extends Fragment
{
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState)
    {
        View rootView = inflater.inflate(R.layout.fragment_news, container, false);

        final ActionBar bar = getActivity().getActionBar();
        bar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);

        TabsAdapter adapter = new TabsAdapter(getActivity().getSupportFragmentManager());

        final ViewPager pager = (ViewPager) rootView.findViewById(R.id.menu_pager);
        pager.setAdapter(adapter);
        pager.setOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageSelected(int index)
            {
                bar.setSelectedNavigationItem(index);
            }

            @Override
            public void onPageScrolled(int arg0, float arg1, int arg2)
            {
            }

            @Override
            public void onPageScrollStateChanged(int arg0)
            {
            }
        });

        ActionBar.TabListener listener = new ActionBar.TabListener() {
            @Override
            public void onTabUnselected(Tab tab, FragmentTransaction ft)
            {
            }

            @Override
            public void onTabSelected(Tab tab, FragmentTransaction ft)
            {
                pager.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabReselected(Tab tab, FragmentTransaction ft)
            {
            }
        };

        bar.removeAllTabs();
        for (int i = 0; i < adapter.getCount(); i++)
        {
            bar.addTab(bar.newTab().setText(adapter.getPageTitle(i)).setTabListener(listener));
        }

        return rootView;
    }

    private static class TabsAdapter extends FragmentStatePagerAdapter
    {
        public final static String[] titles = { "Amis", "Pros", "Tous", };

        public TabsAdapter(FragmentManager fm)
        {
            super(fm);
        }

        @Override
        public Fragment getItem(int index)
        {
            Fragment fragment = new MainTabFragment();
            Bundle args = new Bundle();

            args.putInt(MainTabFragment.ARG_INDEX, index);
            fragment.setArguments(args);

            return fragment;
        }

        @Override
        public int getCount()
        {
            return 3;
        }

        @Override
        public CharSequence getPageTitle(int index)
        {
            return titles[index];
        }
    }
}
