package com.three_petals.utils;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.content.pm.Signature;
import android.util.Base64;
import android.util.Log;

import com.facebook.Request;
import com.facebook.Response;
import com.facebook.Session;
import com.facebook.Session.OpenRequest;
import com.facebook.Session.StatusCallback;
import com.facebook.SessionState;
import com.facebook.model.GraphUser;
import com.three_petals.MainActivity;
import com.three_petals.activity.MainMenu;
import com.three_petals.info.User;

public class FbApi
{
    /*le sdk de facebook ne permetant de ce connecter qu'avec les droit par default, on refait la methode
     * openActiveSession pour ce connecter avec les droit necessaire*/
    private static Session openActiveSession(Activity activity, boolean allowLoginUI, StatusCallback callback, List<String> permissions)
    {
        OpenRequest openRequest = new OpenRequest(activity).setPermissions(permissions).setCallback(callback);
        Session session = new Session.Builder(activity).build();
        if (SessionState.CREATED_TOKEN_LOADED.equals(session.getState()) || allowLoginUI)
        {
            Session.setActiveSession(session);
            session.openForRead(openRequest);
            return session;
        }
        return null;
    }

    /*methode qui permet de ce connecter via facebook*/
    public static void login(Context context)
    {
        List<String> permissions = new ArrayList<String>(); //list de permission
        permissions.add("email");
        
        /*on appel notre propre methode avec la list de permission*/
        openActiveSession((Activity) context, true, new Session.StatusCallback()
        {
            /*call = callback appel quand facebook rpond a l'ouverture de session*/
            @Override
            public void call(Session session, SessionState state, Exception exception)
            {
                if (exception != null)
                {
                    MakeLog.log("exception = " + exception.getMessage());
                }
                if (state.isOpened())
                {
                    Request.newMeRequest(session, new Request.GraphUserCallback()
                    {
                        @Override
                        public void onCompleted(GraphUser user, Response response)
                        {
                            if (user != null)
                            {  
                                MakeLog.log("user != NULL (fbApi)");
                                User.initInstance(user);
                                MainMenu.AffMainMenu(MainActivity.instance);
                            }
                            else
                            {
                                MakeLog.log("user = NULL (fbApi)");
                            }
                        }
                    }).executeAsync();
                }
            }
        }, permissions);
    }
    public static String printKeyHash(Activity context)
    {
        PackageInfo packageInfo;
        String key = null;
        try
        {

            // getting application package name, as defined in manifest
            String packageName = context.getApplicationContext().getPackageName();

            // Retriving package info
            packageInfo = context.getPackageManager().getPackageInfo(packageName, PackageManager.GET_SIGNATURES);

            Log.e("Package Name=", context.getApplicationContext().getPackageName());

            for (Signature signature : packageInfo.signatures)
            {
                MessageDigest md = MessageDigest.getInstance("SHA");
                md.update(signature.toByteArray());
                key = new String(Base64.encode(md.digest(), 0));

                // String key = new String(Base64.encodeBytes(md.digest()));
                Log.e("Key Hash=", key);

            }
        } catch (NameNotFoundException e1)
        {
            Log.e("Name not found", e1.toString());
        }

        catch (NoSuchAlgorithmException e)
        {
            Log.e("No such an algorithm", e.toString());
        } catch (Exception e)
        {
            Log.e("Exception", e.toString());
        }

        return key;
    }
}
